# Automatic Record Metadata

As you design your Object Type Data Schema, keep in mind that there are several things that are automatically generated, stored, and kept up to date as metadata for a record, so you can conveniently use these values throughout your solution and don't need to include them in the Data Schema itself.

* `createdAt`: ISO 8601 date and time
* `updatedAt`: ISO 8601 date and time
* `hash`: using all Record details that are not in `_metaData`, this unique 64-character alphanumeric value is updated with every modification of a Record and can be used in your solution for version control, change validation, and concurrency control (only the version of the record you expect to be updated, is updated), and other purposes
* `schema`: identifier for the Object Type Data Schema
* `type`: for Object Types that you create in Contextual, always "custom"
* `secrets`: an array containing the names of any properties that were typed as `secret` in your Data Schema

{% code title="Record Metadata Example" lineNumbers="true" %}

```json
"_metaData": {
  "createdAt": "2024-05-09T14:22:50.588Z",
  "hash": "894ab5c5bc0f03daca18bfc835d8fbf4ca315842f24d7d696b5b436222aa5eed",
  "id": "87111",
  "schema": "native-object:zipcodes",
  "type": "custom",
  "updatedAt": "2024-05-09T14:22:50.588Z",
  "secrets": []
}
```

{% endcode %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.contextual.io/documentation-and-resources/components-and-data/object-types/object-type-details/data-schema/automatic-metadata.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
